/*#######################################################################################
AVR DCF77 Uhr 

#######################################################################################*/

#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>

#include <clock.c>
// #include "lcd88.h"
#include <lcd-routines.c>




// Initialisierung der Textausgabe und der AUs- und Eingnge
void AVR_Init(void)
{
	lcd_init();
    // Port D initialization
    // PD0   out LED4 gelb
    // PD1   out LED5 gelb	
    // PD2   in   INT0/SA user	0x04	
    // PD3   in   INT1/SB user	0x08
    // PD4   out LED2 grn
    // PD5   out LED6 gelb
    // PD6   out LED7 rot
    // PD7   out LED8 rot
	DDRD=0xF3;
    PORTD=0x00;
	// PC0   out LED1 grn
    // PC1   out LED3 grn	
	DDRC|=0x03;  // LED C0 und C1 auf Ausgang
	PORTC=0x00;
}


char DCFTime[20];
char DCFDate[20];
int lastsecond;


//Hauptprogramm
int main (void)
//############################################################################
{
// LCD und Ein- und AUsgnge initialisieren
	AVR_Init();

//Globale Interrupts einschalten
	sei();

//Starten der DCF77 Uhr
	lastsecond = 99;
	Start_Clock();
    
//Ausgabe der Zeit auf dem LCD Display in einer Endlosschleife
	while (1)
	{
// nur ausgeben, wenn neue Daten vorhanden sind - nicht lschen, einfach berschreiben	
		if (lastsecond != ss)
		{
			lastsecond = ss;
// Erste Zeile: Uhrzeit
			sprintf(DCFTime, "%02u:%02u:%02u", hh, mm, ss);
			lcd_setcursor(0,1);
			lcd_string(DCFTime);
		
// Zweite Zeile: Datum	
			sprintf(DCFDate, "%02u.%02u.%04u", day, mon, year);
			lcd_setcursor(0,2);
			lcd_string(DCFDate);

		}	
	}
return (1);
}

